package org.zkoss.zss.jsfdemo;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.select.SelectorComposer;
import org.zkoss.zk.ui.select.annotation.Listen;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zss.api.Range;
import org.zkoss.zss.api.Ranges;
import org.zkoss.zss.ui.AuxAction;
import org.zkoss.zss.ui.Spreadsheet;
import org.zkoss.zss.ui.event.CellAreaEvent;
import org.zkoss.zss.ui.event.SheetSelectEvent;
import org.zkoss.zss.ui.event.StopEditingEvent;

@ManagedBean(name= "bookBean")
@SessionScoped
public class BookBean extends SelectorComposer<Component>{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	

	@Override
    public void doAfterCompose(Component comp) throws Exception { 
        // Funciona em ZKSS 3.8
		for(Component c : comp.getRoot().getDesktop().getComponents()){
			if(c instanceof Spreadsheet){
		        Spreadsheet ss = (Spreadsheet) c;        
		        ss.disableUserAction(AuxAction.ADD_SHEET, true);
		        ss.disableUserAction(AuxAction.RENAME_SHEET, true);
		        ss.disableUserAction(AuxAction.DELETE_SHEET, true);        
		        ss.disableUserAction(AuxAction.COPY_SHEET, true);
		        ss.disableUserAction(AuxAction.MOVE_SHEET_LEFT, true);
		        ss.disableUserAction(AuxAction.MOVE_SHEET_RIGHT, true);
		        ss.disableUserAction(AuxAction.PROTECT_SHEET, true);   
//		        ss.disableUserAction(AuxAction.HIDE_SHEET, true);      
//		        ss.disableUserAction(AuxAction.UNHIDE_SHEET, true); 
			}
		}		               
        super.doAfterCompose(comp);  //wire variables and event listeners
        	
    }
	
	@Listen("onSheetSelect  = #ssheet")
	public void onSheetSelect(SheetSelectEvent event){ 
		Clients.showNotification("mensagem do spreadsheet onSheetSelect","info",event.getTarget(),null,2000,true);  
	}
	
	@Listen("onAfterCellChange = #ssheet")
    public void onAfterCellChange(CellAreaEvent event){ 
		Clients.showNotification("mensagem do spreadsheet onAfterCellChange","info",event.getTarget(),null,2000,true);  
    }
	
	@Listen("onStopEditing = #ssheet")
    public void onStopEditing(StopEditingEvent event){
		Clients.showNotification("mensagem do spreadsheet onStopEditing","info",event.getTarget(),null,2000,true);  
	}
	
	
}
